#include "bag.h"

/*
 2 "blank" tiles (scoring 0 points), 9 As (1 point), 2 Bs (3), 2 Cs (3), 4 Ds (2), 
 12 Es (1), 2 Fs (4), 3 Gs (2), 2 Hs (4), 9 Is (1), 1 J (8), 1 K (5), 4 Ls (1), 
 2 Ms (3), 6 Ns (1), 8 Os (1), 2 Ps (3), 1 Q (10), 6 Rs (1), 4 Ss (1), 6 Ts (1),
 4 Us (1), 2 Vs (4), 2 Ws (4), 1 X (8), 2 Ys (4), and 1 Z (10).

  */

int CBag::tokenData[26][2]=
{
	{9,  1}, // As (1 point),
	{2,  3},// Bs (3),
	{2,  3},// Cs (3), 
	{4,  2},// Ds (2), 
	{12, 1},//Es (1),
	{2,  4},// Fs (4),
	{3,  2},//Gs (2), 
	{2,  4},//Hs (4),
	{9,  1},// Is (1), 
	{1,  8},// J (8), 
	{1,  5},// K (5), 
	{5,  1},// Ls (1),
	{2,  3},// Ms (3),
	{6,  1},//Ns (1), 
	{8,  1},// Os (1),
	{2,  3},// Ps (3), 
	{1,  9},// Q (10),
	{6,  1},// Rs (1),
	{4,  1},// Ss (1), 
	{6,  1},// Ts (1),
	{5,  1},// Us (1),
	{2,  4},// Vs (4),
	{2,  4},// Ws (4),
	{1,  8},// X (8),
	{2,  4},// Ys (4), and 
	{1,  9}// Z (10).
//	{2,   0}//blank token valued 255
};


bool CBag::removeLetter(char ch, CToken& result)
{
	for (int i=CTokens::pos-1; i>=0; i--)
	{
		if (CTokens::tokens[i].getValue()==ch)
		{
			//swap, this is INEFFICIENT!
			result=CTokens::tokens[i];
			CTokens::tokens[i]=CTokens::tokens[CTokens::pos-1];
			CTokens::tokens[CTokens::pos-1]=result;
			return removeLetter(result);
		}
	}
	return false;
}


bool CBag::removeLetter(CToken& result)
{
	if (tokenLeft==0)
	{
		return false;
	}
	result=tokens[--tokenLeft];
	return true;
}

bool CBag::addLetter(const CToken& target)
{
	if (tokenLeft==DefaultNumberOfToken)
	{
		return false;
	}
	tokens[tokenLeft++]=target;
	return true;
}



CBag::CBag():CTokens(DefaultNumberOfToken)
{
	bag.setNumber(DefaultNumberOfToken);
	tokenLeft=DefaultNumberOfToken;
	int index=0;
	for (int i=0; i<26; i++)
	{
		int j=0;
		while (j<tokenData[i][BagTokenNumber])
		{
			/*
			if (i!=26)
			{
				tokens[index].setValue(i+'A');
			}
			else
			{
				tokens[index].setValue((char)DefaultBlankTokenValue);
			}
			*/
			tokens[index].setValue(i+'A');
			j++;//always
			index++;
		}
	}
	shuffle();
	CTokens::pos=DefaultNumberOfToken;
}

void CBag::show()
{
	bag.setNumber(tokenLeft);
	bag.display(DefaultBag_x, DefaultBag_y);
}

int CBag::getTokenNumber(char ch)
{
	return tokenData[ch-'A'][BagTokenNumber];
}

/*
int CBag::getBlankNumber()
{
	return tokenData[DefaultBlandTokenIndex][BagTokenNumber];
}

void CBag::setBlankNumber(int newNum)
{
	tokenLeft+= newNum-tokenData[DefaultBlandTokenIndex][BagTokenNumber];
	//????
	tokenData[DefaultBlandTokenIndex][BagTokenNumber]=newNum;
}
*/

void CBag::setTokenNumber(char ch, int newNum)
{
	tokenLeft+=newNum-tokenData[ch-'A'][BagTokenNumber];
	tokenData[ch-'A'][BagTokenNumber]=newNum;
}

void CBag::setTokenPoint(char ch, int newPoint)
{
	tokenData[ch-'A'][BagTokenPoints]=newPoint;
}

int CBag::getTokenPoint(char ch)
{
	return tokenData[ch-'A'][BagTokenPoints];
}





