#ifndef BOARD_H
#define BOARD_H

#include "cell.h"

class CBoard
{
private:
	int curRow, curCol;
	int headRow, headCol;
	int exchRow, exchCol;
	bool isVer;
	bool isFirst;
	char buffer[MaxBoardSize];
	bool doFindStr(int& exchangedIndex);
	void setStartPoint();
	void getFirstStr(int& exchangedIndex);

	int findHead(int startRow, int startCol, bool isVertical);
	int score;
protected:
	CCell** board;
	int boardWidth;
	void initialize(int size);
public:
	CBoard(int size=DefaultBoardSize);
	void setSize(int size);
	void display(int x, int y);
	char getValue(int r, int c);
	void setValue(int r, int c, char ch);
	void setValue(char** matrix);
	bool placeWord(int r, int c, const char* str, bool isVertical, int index);
	void update(bool rollBack=false);
	void show();
	char* getNextStr(int& exchangedIndex);
	char* verifyStr(int& exchangedIndex);
};

#endif