#ifndef  CONTROL_H
#define  CONTROL_H
#include "roverType.h"
#include "listener.h"
#include "player.h"
#include "message.h"
#include "bag.h"
#include "deck.h"
#include "board.h"
#include "menu.h"
#include "dictionary.h"
#include "scoreboard.h"
#include "logo.h"
#include "background.h"


class CControl
{
private:
	char playerName[2][DefaultScoreBoardWidth+1];
	char* fileName;
	CScoreBoard scoreBoard;
	CBackGround backGround;
	CLogo logo;
	CListener listener;
	CPlayer player[2];
	CMessage message;
	CMenu  menu;
	CBag bag;
	int turn;
	void initPlayGame();
	void initStartGame();
	void initEndGame();
	int doFormWord();
	int doSelectCard();
	int doSelectLetter();
	int doTrade();
	int doPickCard();
	int doDiscard();
	int doEndRound();
	int doCancel();
	void fillUpRack();
	int listenMenu();
	int listenInt();
	char listenChar();
	int listenIndex();
	void showMessage(int msgID);
	void nextTurn();
	void calculateScore();
	void getPlayerName(int index);
public:
	void setInputFile(char* inputFileName);
	void startLogo();
	void startGame();
	void playGame();
	void endGame();
	void show();
	CControl();
};


#endif