#include "deck.h"

char cardValue[12]={'2','3','4','5','6','7','8','9','J','Q','K','A'};
int suitValue[4]={Club, Diamond, Heart, Spade};

CDeck::CDeck(bool isEmpty):CTokens(52)
{   
	//do initialize
	faceDown=true;
	for(int i=0;i<4;i++)
	{		
		for(int j=0;j<13; j++)
		{
			if (j==12)
			{
				tokens[i*13+j].setNumber(10);
			}
			else
			{
				tokens[i*13+j].setValue(cardValue[j]);
			}
			tokens[i*13+j].setSuit(suitValue[i]);
		}
	} 
	if (isEmpty)
	{
		pos=0;	
	}
	else
	{
		pos=len;
	}
	deckBack.setNumber(pos);
}

void CDeck::showHand()
{
	for (int i=0; i<4; i++)
	{
		for (int j=0; j<13; j++)
		{
			tokens[i*13+j].display(j*4, i*4);
		}
	}
}

bool CDeck::addCard(const CToken& card)
{
	if (pos<len)
	{
		deckBack.setNumber(pos+1);
	}
	return pushToken(card);
}

bool CDeck::removeCard(CToken& card)
{
	if (pos>0)
	{
		deckBack.setNumber(pos-1);
	}
	return popToken(card);
}

void CDeck::setFace(bool isFaceDown)
{
	faceDown=isFaceDown;
}

void CDeck::display(int x, int y)
{
	if (faceDown||pos==0)
	{
		deckBack.display(x, y);
	}
	else
	{
		tokens[pos-1].display(x, y);
	}
}

void CDeck::setCoord(int newX, int newY)
{
	x=newX;
	y=newY;
}

void CDeck::show()
{
	display(x,y);
}















