#ifndef DICTIONARY_H
#define DICTIONARY_H

#include "RoverType.h"


struct Letter
{
	char ch;
	Letter* next;
	Letter* son;
	bool end;
};

class CDictionary
{
private:
	Letter* root[52];
	Letter* current;
	Letter* findBrother(Letter* brother, char ch);
	Letter* createLetter(char ch);
	Letter* addSon(char ch);
	int indexOf(char ch);
	bool caseSensitive;
	void change2Capital(char* target, char* source);
public:
	bool addWord(char* str);
	bool findWord(char* str);
	bool readFile(const char* fileName);
	void setCaseSensitive(bool isCaseSensitive);
	CDictionary(bool isCaseSensitive=true);
};

#endif