#include "player.h"


CPlayer::CPlayer()
{
	name=NULL;
	index=-1;
	rackLetter.setCoord(DefaultLetterRack_x, DefaultLetterRack_y);
	rackCard.setCoord(DefaultCardRack_x, DefaultCardRack_y);
	show();
}

void CPlayer::show()
{
	rackLetter.show();
	rackCard.show();
	//to do:
	//here to call scoreboard set current player method
}

void CPlayer::discardCard(int index, CToken& result)
{
	rackCard.removeToken(index, result);
}

void CPlayer::discardLetter(int index, CToken& result)
{
	rackLetter.removeToken(index, result);
}


CPlayer::~CPlayer()
{
	if (name!=NULL)
	{
		delete[]name;
	}
}

void CPlayer::setName(const char* theName)
{
	if (name!=NULL)
	{
		delete[]name;
	}
	name=new char[strlen(theName)+1];
	strcpy(name, theName);
}


const char* CPlayer::getName()
{
	return name;
}

void CPlayer::setCurrentScore(int score)
{
	currentScore=score;
}

int CPlayer::getCurrentScore()
{
	return currentScore;
}

void CPlayer::setTotalScore(int score)
{
	totalScore=score;
}

int CPlayer::getTotalScore()
{
	return totalScore;
}

int CPlayer::getIndex()
{
	return index;
}

bool CPlayer::selectCard(int index)
{
	return rackCard.selectToken(index, false);
}

bool CPlayer::selectLetter(int index)
{
	return rackLetter.selectToken(index);
}

void CPlayer::addCard(const CToken& newToken)
{
	rackCard.addToken(newToken);
	rackCard.show();
}
  
void CPlayer::addLetter(const CToken& newToken)
{
	rackLetter.addToken(newToken);
	rackLetter.show();
}

char* CPlayer::exportWord()
{
	return rackLetter.exportWord();
}
  
bool CPlayer::verifyCards()
{
	return rackCard.verifyCards();
}

bool CPlayer::canAddCard()
{
	return rackCard.canAdd();
}

bool CPlayer::canAddLetter()
{
	return rackLetter.canAdd();
}


void CPlayer::updateCards(bool rollBack)
{
	rackCard.updateRack(rollBack);
}

void CPlayer::updateLetters(bool rollBack)
{
	rackLetter.updateRack(rollBack);
}

void CPlayer::addExchanged(char ch)
{
	rackLetter.addExchanged(ch);
}


