#ifndef CPLAYER_H
#define CPLAYER_H

#include "rovertype.h"
#include "rack.h"
//#include "control.h"

//to do:
//I need charles's CScoreBoard to put an instance inside Player
//so that all set, get method is implemented by CScoreBoard

class CControl;

class CPlayer
{
	friend class CControl;
private:
	char* name;
	CRack rackLetter;
	CRack rackCard;
	int currentScore;
	int totalScore;
	int index;
	bool traded;
	bool formed;
	bool picked;
public:
	CPlayer();
	~CPlayer();
	void setName(const char* theName);
	const char* getName();
	int getCurrentScore();
	void setCurrentScore(int score);
	int getTotalScore();
	void setTotalScore(int score);
	int getIndex(void);
	void setIndex(int theIndex);
	bool selectCard(int index);
	bool selectLetter(int index);
	void addCard(const CToken & newCard );
	void addLetter(const CToken& newLetter);
	char* exportWord();
	bool verifyCards();
	void show();
	void discardCard(int index, CToken& result);
	void discardLetter(int index, CToken& result);
	bool canAddCard();
	bool canAddLetter();
	void updateCards(bool rollBack=false);
	void updateLetters(bool rollBack=false);
	void addExchanged(char ch);
};

#endif