#include "rack.h"


CRummy CRack::rummy;

CRack::CRack():CTokens(7)
{
	selectedCount=7;//means empty at beginning
	for (int i=0; i<7; i++)
	{
		selected[i]=i;
	}
	exchangedIndex=-1;//means no exchanged!!!
	x=y=points=0;
	canRollBack=true;
}


bool CRack::selectToken(int index, bool isLetter)
{
	if (selectedCount==7)
	{
		return false;
	}
	for (int i=0; i<selectedCount; i++)
	{
		if (index==selected[i])
		{
			return false;//means repeat selecting
		}
	}
	selected[selectedCount]=index;
	if (isLetter)
	{
		buffer[selectedCount]=tokens[index].getValue();	
	}
	else
	{
		cardBuf[selectedCount]=tokens[index];
	}
	tokens[index].setBKGroundColor(DefaultSelectedBKGColor);	
	tokens[index].setFontColor(DefaultSelectedFontColor);
	selectedCount++;
	show();
	return true;
}

//this is rackCard method
bool CRack::verifyCards()
{
	if (selectedCount==0)
	{
		return false;
	}
	return rummy.verify(cardBuf, selectedCount, points);
}

void CRack::addToken(const CToken& newToken)
{
	if (selectedCount>0)
	{
		tokens[selected[--selectedCount]]=newToken;
	}
}


void CRack::addExchanged(char ch)
{
	exchanged=ch;
	exchangedIndex=selectedCount;
}


void CRack::show()
{
	display(x,y);
}


void CRack::removeToken(int index, CToken& result)
{
	result=tokens[index];
	tokens[index]=empty;
}

char* CRack::exportWord()
{
	//insert the exchanged letter
	if (exchangedIndex!=-1)
	{
		for (int i=selectedCount; i>exchangedIndex; i--)
		{
			buffer[i]=buffer[i-1];
		}
		buffer[exchangedIndex]=exchanged; //insert the char
		buffer[selectedCount+1]='\0';
	}
	else
	{
		buffer[selectedCount]='\0';
	}
	return buffer;
}

void CRack::updateRack(bool rollBack)
{
	if(rollBack)
	{
		if (canRollBack)
		{
			for(int i=0; i<selectedCount;i++)
			{
				tokens[selected[i]].setBKGroundColor(DefaultBKGroundColor);
				tokens[selected[i]].setFontColor(DefaultFontColor);			
			}
			selectedCount=0;
			exchangedIndex=-1;
		}
	}
	else
	{
		for(int i=0; i<selectedCount;i++)
		{
			tokens[selected[i]].setBKGroundColor(DefaultBKGroundColor);
			tokens[selected[i]].setFontColor(DefaultFontColor);	
			tokens[selected[i]]=empty;			
		}        
		exchangedIndex=-1;//should I do at this moment?
	}
	show();
}
