#include "token.h"
#include "tile.h"

CToken& CToken::operator =(const CToken& theToken)
{	
	for (int i=0; i<3; i++)
	{
		for (int j=0; j<3; j++)
		{
			block[i][j].setValue(theToken.block[i][j].getValue());
		}
	}
	return *this;
}

void CToken::setSuit(int theSuit)
{
	block[0][0].setValue(theSuit);
	block[2][2].setValue(theSuit);
}

CToken::CToken(char ch):CBlock(3)
{
	block[1][1].setValue(ch);	
}

int CToken::getNumber()
{
	if (block[1][0].getValue()!=0)
	{
		return (block[1][0].getValue()-'0')*10+block[1][1].getValue()-'0';
	}
	if (block[1][1].getValue()>'9')
	{
		switch(block[1][1].getValue())
		{
			case 'J': return 11;
			case 'Q': return 12;
			case 'K': return 13;
			case 'A': return 14;
		}
	}
	return block[1][1].getValue()-'0';
}

void CToken::setNumber(int num)
{
	//in no condition, this would happen
	block[1][0].setValue(0);
	block[1][1].setValue(0);
	block[1][2].setValue(0);
	if (num>999)
	{
		return ;
	}
	if (num>99)
	{
		block[1][0].setValue(num/100+'0');
		block[1][1].setValue((num%100)/10+'0');
		block[1][2].setValue((num%100)%10 + '0');
	}
	else
	{
		if (num>9)
		{
			block[1][0].setValue(num/10+'0');
			block[1][1].setValue(num%10+'0');
		}
		else
		{
			block[1][1].setValue(num+'0');
		}
	}
}

CToken::CToken(int num)
{
	initialize();
	setNumber(num);
}

int CToken::getSuit()
{
	return block[0][0].getValue();
}

CCardBack::CCardBack()
{
	block[0][0].setValue(Club);
	block[0][2].setValue(Diamond);
	block[2][0].setValue(Heart);
	block[2][2].setValue(Spade);
	for (int i=0; i<3; i++)
	{
		for (int j=0; j<3; j++)
		{
			block[i][j].setBKGroundColor(DefaultCardBackBKGroundColor);
			block[i][j].setFontColor(DefaultCardBackFontColor);
		}
	}
}
